// Code generated by go-swagger; DO NOT EDIT.

package events

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"

	"gitlab.com/gitlab-org/opstrace/opstrace/go/pkg/errortracking/gen/models"
)

// PostProjectsAPIProjectIDEnvelopeOKCode is the HTTP code returned for type PostProjectsAPIProjectIDEnvelopeOK
const PostProjectsAPIProjectIDEnvelopeOKCode int = 200

/*
PostProjectsAPIProjectIDEnvelopeOK Accepted. Event will be created async

swagger:response postProjectsApiProjectIdEnvelopeOK
*/
type PostProjectsAPIProjectIDEnvelopeOK struct {
	/*The maximum number of requests allowed within the window.

	 */
	XSentryRateLimitLimit int64 `json:"X-Sentry-Rate-Limit-Limit"`
	/*The number of requests this caller has left on this endpoint within the current window.

	 */
	XSentryRateLimitRemaining int64 `json:"X-Sentry-Rate-Limit-Remaining"`
	/*The time when the next rate limit window begins and the count resets, measured in UTC seconds from epoch.

	 */
	XSentryRateLimitReset int64 `json:"X-Sentry-Rate-Limit-Reset"`

	/*
	  In: Body
	*/
	Payload *models.ErrorEvent `json:"body,omitempty"`
}

// NewPostProjectsAPIProjectIDEnvelopeOK creates PostProjectsAPIProjectIDEnvelopeOK with default headers values
func NewPostProjectsAPIProjectIDEnvelopeOK() *PostProjectsAPIProjectIDEnvelopeOK {

	return &PostProjectsAPIProjectIDEnvelopeOK{}
}

// WithXSentryRateLimitLimit adds the xSentryRateLimitLimit to the post projects Api project Id envelope o k response
func (o *PostProjectsAPIProjectIDEnvelopeOK) WithXSentryRateLimitLimit(xSentryRateLimitLimit int64) *PostProjectsAPIProjectIDEnvelopeOK {
	o.XSentryRateLimitLimit = xSentryRateLimitLimit
	return o
}

// SetXSentryRateLimitLimit sets the xSentryRateLimitLimit to the post projects Api project Id envelope o k response
func (o *PostProjectsAPIProjectIDEnvelopeOK) SetXSentryRateLimitLimit(xSentryRateLimitLimit int64) {
	o.XSentryRateLimitLimit = xSentryRateLimitLimit
}

// WithXSentryRateLimitRemaining adds the xSentryRateLimitRemaining to the post projects Api project Id envelope o k response
func (o *PostProjectsAPIProjectIDEnvelopeOK) WithXSentryRateLimitRemaining(xSentryRateLimitRemaining int64) *PostProjectsAPIProjectIDEnvelopeOK {
	o.XSentryRateLimitRemaining = xSentryRateLimitRemaining
	return o
}

// SetXSentryRateLimitRemaining sets the xSentryRateLimitRemaining to the post projects Api project Id envelope o k response
func (o *PostProjectsAPIProjectIDEnvelopeOK) SetXSentryRateLimitRemaining(xSentryRateLimitRemaining int64) {
	o.XSentryRateLimitRemaining = xSentryRateLimitRemaining
}

// WithXSentryRateLimitReset adds the xSentryRateLimitReset to the post projects Api project Id envelope o k response
func (o *PostProjectsAPIProjectIDEnvelopeOK) WithXSentryRateLimitReset(xSentryRateLimitReset int64) *PostProjectsAPIProjectIDEnvelopeOK {
	o.XSentryRateLimitReset = xSentryRateLimitReset
	return o
}

// SetXSentryRateLimitReset sets the xSentryRateLimitReset to the post projects Api project Id envelope o k response
func (o *PostProjectsAPIProjectIDEnvelopeOK) SetXSentryRateLimitReset(xSentryRateLimitReset int64) {
	o.XSentryRateLimitReset = xSentryRateLimitReset
}

// WithPayload adds the payload to the post projects Api project Id envelope o k response
func (o *PostProjectsAPIProjectIDEnvelopeOK) WithPayload(payload *models.ErrorEvent) *PostProjectsAPIProjectIDEnvelopeOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the post projects Api project Id envelope o k response
func (o *PostProjectsAPIProjectIDEnvelopeOK) SetPayload(payload *models.ErrorEvent) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *PostProjectsAPIProjectIDEnvelopeOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header X-Sentry-Rate-Limit-Limit

	xSentryRateLimitLimit := swag.FormatInt64(o.XSentryRateLimitLimit)
	if xSentryRateLimitLimit != "" {
		rw.Header().Set("X-Sentry-Rate-Limit-Limit", xSentryRateLimitLimit)
	}

	// response header X-Sentry-Rate-Limit-Remaining

	xSentryRateLimitRemaining := swag.FormatInt64(o.XSentryRateLimitRemaining)
	if xSentryRateLimitRemaining != "" {
		rw.Header().Set("X-Sentry-Rate-Limit-Remaining", xSentryRateLimitRemaining)
	}

	// response header X-Sentry-Rate-Limit-Reset

	xSentryRateLimitReset := swag.FormatInt64(o.XSentryRateLimitReset)
	if xSentryRateLimitReset != "" {
		rw.Header().Set("X-Sentry-Rate-Limit-Reset", xSentryRateLimitReset)
	}

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// PostProjectsAPIProjectIDEnvelopeBadRequestCode is the HTTP code returned for type PostProjectsAPIProjectIDEnvelopeBadRequest
const PostProjectsAPIProjectIDEnvelopeBadRequestCode int = 400

/*
PostProjectsAPIProjectIDEnvelopeBadRequest Bad request

swagger:response postProjectsApiProjectIdEnvelopeBadRequest
*/
type PostProjectsAPIProjectIDEnvelopeBadRequest struct {
}

// NewPostProjectsAPIProjectIDEnvelopeBadRequest creates PostProjectsAPIProjectIDEnvelopeBadRequest with default headers values
func NewPostProjectsAPIProjectIDEnvelopeBadRequest() *PostProjectsAPIProjectIDEnvelopeBadRequest {

	return &PostProjectsAPIProjectIDEnvelopeBadRequest{}
}

// WriteResponse to the client
func (o *PostProjectsAPIProjectIDEnvelopeBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(400)
}

// PostProjectsAPIProjectIDEnvelopeTooManyRequestsCode is the HTTP code returned for type PostProjectsAPIProjectIDEnvelopeTooManyRequests
const PostProjectsAPIProjectIDEnvelopeTooManyRequestsCode int = 429

/*
PostProjectsAPIProjectIDEnvelopeTooManyRequests Resource limits exceeded

swagger:response postProjectsApiProjectIdEnvelopeTooManyRequests
*/
type PostProjectsAPIProjectIDEnvelopeTooManyRequests struct {
	/*Number of seconds after which requests will be permitted again

	 */
	RetryAfter int64 `json:"Retry-After"`
	/*The maximum number of requests allowed within the window.

	 */
	XSentryRateLimitLimit int64 `json:"X-Sentry-Rate-Limit-Limit"`
	/*The time when the next rate limit window begins and the count resets, measured in UTC seconds from epoch.

	 */
	XSentryRateLimitReset int64 `json:"X-Sentry-Rate-Limit-Reset"`
	/*Detailed list of all rate limits that apply per data category, with seconds remaining untill they reset

	 */
	XSentryRateLimits string `json:"X-Sentry-Rate-Limits"`
}

// NewPostProjectsAPIProjectIDEnvelopeTooManyRequests creates PostProjectsAPIProjectIDEnvelopeTooManyRequests with default headers values
func NewPostProjectsAPIProjectIDEnvelopeTooManyRequests() *PostProjectsAPIProjectIDEnvelopeTooManyRequests {

	return &PostProjectsAPIProjectIDEnvelopeTooManyRequests{}
}

// WithRetryAfter adds the retryAfter to the post projects Api project Id envelope too many requests response
func (o *PostProjectsAPIProjectIDEnvelopeTooManyRequests) WithRetryAfter(retryAfter int64) *PostProjectsAPIProjectIDEnvelopeTooManyRequests {
	o.RetryAfter = retryAfter
	return o
}

// SetRetryAfter sets the retryAfter to the post projects Api project Id envelope too many requests response
func (o *PostProjectsAPIProjectIDEnvelopeTooManyRequests) SetRetryAfter(retryAfter int64) {
	o.RetryAfter = retryAfter
}

// WithXSentryRateLimitLimit adds the xSentryRateLimitLimit to the post projects Api project Id envelope too many requests response
func (o *PostProjectsAPIProjectIDEnvelopeTooManyRequests) WithXSentryRateLimitLimit(xSentryRateLimitLimit int64) *PostProjectsAPIProjectIDEnvelopeTooManyRequests {
	o.XSentryRateLimitLimit = xSentryRateLimitLimit
	return o
}

// SetXSentryRateLimitLimit sets the xSentryRateLimitLimit to the post projects Api project Id envelope too many requests response
func (o *PostProjectsAPIProjectIDEnvelopeTooManyRequests) SetXSentryRateLimitLimit(xSentryRateLimitLimit int64) {
	o.XSentryRateLimitLimit = xSentryRateLimitLimit
}

// WithXSentryRateLimitReset adds the xSentryRateLimitReset to the post projects Api project Id envelope too many requests response
func (o *PostProjectsAPIProjectIDEnvelopeTooManyRequests) WithXSentryRateLimitReset(xSentryRateLimitReset int64) *PostProjectsAPIProjectIDEnvelopeTooManyRequests {
	o.XSentryRateLimitReset = xSentryRateLimitReset
	return o
}

// SetXSentryRateLimitReset sets the xSentryRateLimitReset to the post projects Api project Id envelope too many requests response
func (o *PostProjectsAPIProjectIDEnvelopeTooManyRequests) SetXSentryRateLimitReset(xSentryRateLimitReset int64) {
	o.XSentryRateLimitReset = xSentryRateLimitReset
}

// WithXSentryRateLimits adds the xSentryRateLimits to the post projects Api project Id envelope too many requests response
func (o *PostProjectsAPIProjectIDEnvelopeTooManyRequests) WithXSentryRateLimits(xSentryRateLimits string) *PostProjectsAPIProjectIDEnvelopeTooManyRequests {
	o.XSentryRateLimits = xSentryRateLimits
	return o
}

// SetXSentryRateLimits sets the xSentryRateLimits to the post projects Api project Id envelope too many requests response
func (o *PostProjectsAPIProjectIDEnvelopeTooManyRequests) SetXSentryRateLimits(xSentryRateLimits string) {
	o.XSentryRateLimits = xSentryRateLimits
}

// WriteResponse to the client
func (o *PostProjectsAPIProjectIDEnvelopeTooManyRequests) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Retry-After

	retryAfter := swag.FormatInt64(o.RetryAfter)
	if retryAfter != "" {
		rw.Header().Set("Retry-After", retryAfter)
	}

	// response header X-Sentry-Rate-Limit-Limit

	xSentryRateLimitLimit := swag.FormatInt64(o.XSentryRateLimitLimit)
	if xSentryRateLimitLimit != "" {
		rw.Header().Set("X-Sentry-Rate-Limit-Limit", xSentryRateLimitLimit)
	}

	// response header X-Sentry-Rate-Limit-Reset

	xSentryRateLimitReset := swag.FormatInt64(o.XSentryRateLimitReset)
	if xSentryRateLimitReset != "" {
		rw.Header().Set("X-Sentry-Rate-Limit-Reset", xSentryRateLimitReset)
	}

	// response header X-Sentry-Rate-Limits

	xSentryRateLimits := o.XSentryRateLimits
	if xSentryRateLimits != "" {
		rw.Header().Set("X-Sentry-Rate-Limits", xSentryRateLimits)
	}

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(429)
}

// PostProjectsAPIProjectIDEnvelopeInternalServerErrorCode is the HTTP code returned for type PostProjectsAPIProjectIDEnvelopeInternalServerError
const PostProjectsAPIProjectIDEnvelopeInternalServerErrorCode int = 500

/*
PostProjectsAPIProjectIDEnvelopeInternalServerError Internal error

swagger:response postProjectsApiProjectIdEnvelopeInternalServerError
*/
type PostProjectsAPIProjectIDEnvelopeInternalServerError struct {
}

// NewPostProjectsAPIProjectIDEnvelopeInternalServerError creates PostProjectsAPIProjectIDEnvelopeInternalServerError with default headers values
func NewPostProjectsAPIProjectIDEnvelopeInternalServerError() *PostProjectsAPIProjectIDEnvelopeInternalServerError {

	return &PostProjectsAPIProjectIDEnvelopeInternalServerError{}
}

// WriteResponse to the client
func (o *PostProjectsAPIProjectIDEnvelopeInternalServerError) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(500)
}
